// Code generated by go-swagger; DO NOT EDIT.

package containers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/skupperproject/skupper/client/generated/libpod/models"
)

// NewContainerCreateLibpodParams creates a new ContainerCreateLibpodParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewContainerCreateLibpodParams() *ContainerCreateLibpodParams {
	return &ContainerCreateLibpodParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewContainerCreateLibpodParamsWithTimeout creates a new ContainerCreateLibpodParams object
// with the ability to set a timeout on a request.
func NewContainerCreateLibpodParamsWithTimeout(timeout time.Duration) *ContainerCreateLibpodParams {
	return &ContainerCreateLibpodParams{
		timeout: timeout,
	}
}

// NewContainerCreateLibpodParamsWithContext creates a new ContainerCreateLibpodParams object
// with the ability to set a context for a request.
func NewContainerCreateLibpodParamsWithContext(ctx context.Context) *ContainerCreateLibpodParams {
	return &ContainerCreateLibpodParams{
		Context: ctx,
	}
}

// NewContainerCreateLibpodParamsWithHTTPClient creates a new ContainerCreateLibpodParams object
// with the ability to set a custom HTTPClient for a request.
func NewContainerCreateLibpodParamsWithHTTPClient(client *http.Client) *ContainerCreateLibpodParams {
	return &ContainerCreateLibpodParams{
		HTTPClient: client,
	}
}

/*
ContainerCreateLibpodParams contains all the parameters to send to the API endpoint

	for the container create libpod operation.

	Typically these are written to a http.Request.
*/
type ContainerCreateLibpodParams struct {

	/* Create.

	   attributes for creating a container
	*/
	Create *models.SpecGenerator

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the container create libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ContainerCreateLibpodParams) WithDefaults() *ContainerCreateLibpodParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the container create libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ContainerCreateLibpodParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the container create libpod params
func (o *ContainerCreateLibpodParams) WithTimeout(timeout time.Duration) *ContainerCreateLibpodParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the container create libpod params
func (o *ContainerCreateLibpodParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the container create libpod params
func (o *ContainerCreateLibpodParams) WithContext(ctx context.Context) *ContainerCreateLibpodParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the container create libpod params
func (o *ContainerCreateLibpodParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the container create libpod params
func (o *ContainerCreateLibpodParams) WithHTTPClient(client *http.Client) *ContainerCreateLibpodParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the container create libpod params
func (o *ContainerCreateLibpodParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCreate adds the create to the container create libpod params
func (o *ContainerCreateLibpodParams) WithCreate(create *models.SpecGenerator) *ContainerCreateLibpodParams {
	o.SetCreate(create)
	return o
}

// SetCreate adds the create to the container create libpod params
func (o *ContainerCreateLibpodParams) SetCreate(create *models.SpecGenerator) {
	o.Create = create
}

// WriteToRequest writes these params to a swagger request
func (o *ContainerCreateLibpodParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Create != nil {
		if err := r.SetBodyParam(o.Create); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
