// Code generated by go-swagger; DO NOT EDIT.

package images

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewImageLoadLibpodParams creates a new ImageLoadLibpodParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewImageLoadLibpodParams() *ImageLoadLibpodParams {
	return &ImageLoadLibpodParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewImageLoadLibpodParamsWithTimeout creates a new ImageLoadLibpodParams object
// with the ability to set a timeout on a request.
func NewImageLoadLibpodParamsWithTimeout(timeout time.Duration) *ImageLoadLibpodParams {
	return &ImageLoadLibpodParams{
		timeout: timeout,
	}
}

// NewImageLoadLibpodParamsWithContext creates a new ImageLoadLibpodParams object
// with the ability to set a context for a request.
func NewImageLoadLibpodParamsWithContext(ctx context.Context) *ImageLoadLibpodParams {
	return &ImageLoadLibpodParams{
		Context: ctx,
	}
}

// NewImageLoadLibpodParamsWithHTTPClient creates a new ImageLoadLibpodParams object
// with the ability to set a custom HTTPClient for a request.
func NewImageLoadLibpodParamsWithHTTPClient(client *http.Client) *ImageLoadLibpodParams {
	return &ImageLoadLibpodParams{
		HTTPClient: client,
	}
}

/*
ImageLoadLibpodParams contains all the parameters to send to the API endpoint

	for the image load libpod operation.

	Typically these are written to a http.Request.
*/
type ImageLoadLibpodParams struct {

	/* Upload.

	   tarball of container image
	*/
	Upload string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the image load libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ImageLoadLibpodParams) WithDefaults() *ImageLoadLibpodParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the image load libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ImageLoadLibpodParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the image load libpod params
func (o *ImageLoadLibpodParams) WithTimeout(timeout time.Duration) *ImageLoadLibpodParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the image load libpod params
func (o *ImageLoadLibpodParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the image load libpod params
func (o *ImageLoadLibpodParams) WithContext(ctx context.Context) *ImageLoadLibpodParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the image load libpod params
func (o *ImageLoadLibpodParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the image load libpod params
func (o *ImageLoadLibpodParams) WithHTTPClient(client *http.Client) *ImageLoadLibpodParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the image load libpod params
func (o *ImageLoadLibpodParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUpload adds the upload to the image load libpod params
func (o *ImageLoadLibpodParams) WithUpload(upload string) *ImageLoadLibpodParams {
	o.SetUpload(upload)
	return o
}

// SetUpload adds the upload to the image load libpod params
func (o *ImageLoadLibpodParams) SetUpload(upload string) {
	o.Upload = upload
}

// WriteToRequest writes these params to a swagger request
func (o *ImageLoadLibpodParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Upload); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
