// Code generated by go-swagger; DO NOT EDIT.

package networks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewNetworkExistsLibpodParams creates a new NetworkExistsLibpodParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNetworkExistsLibpodParams() *NetworkExistsLibpodParams {
	return &NetworkExistsLibpodParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNetworkExistsLibpodParamsWithTimeout creates a new NetworkExistsLibpodParams object
// with the ability to set a timeout on a request.
func NewNetworkExistsLibpodParamsWithTimeout(timeout time.Duration) *NetworkExistsLibpodParams {
	return &NetworkExistsLibpodParams{
		timeout: timeout,
	}
}

// NewNetworkExistsLibpodParamsWithContext creates a new NetworkExistsLibpodParams object
// with the ability to set a context for a request.
func NewNetworkExistsLibpodParamsWithContext(ctx context.Context) *NetworkExistsLibpodParams {
	return &NetworkExistsLibpodParams{
		Context: ctx,
	}
}

// NewNetworkExistsLibpodParamsWithHTTPClient creates a new NetworkExistsLibpodParams object
// with the ability to set a custom HTTPClient for a request.
func NewNetworkExistsLibpodParamsWithHTTPClient(client *http.Client) *NetworkExistsLibpodParams {
	return &NetworkExistsLibpodParams{
		HTTPClient: client,
	}
}

/*
NetworkExistsLibpodParams contains all the parameters to send to the API endpoint

	for the network exists libpod operation.

	Typically these are written to a http.Request.
*/
type NetworkExistsLibpodParams struct {

	/* Name.

	   the name or ID of the network
	*/
	Name string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the network exists libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkExistsLibpodParams) WithDefaults() *NetworkExistsLibpodParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the network exists libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkExistsLibpodParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the network exists libpod params
func (o *NetworkExistsLibpodParams) WithTimeout(timeout time.Duration) *NetworkExistsLibpodParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the network exists libpod params
func (o *NetworkExistsLibpodParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the network exists libpod params
func (o *NetworkExistsLibpodParams) WithContext(ctx context.Context) *NetworkExistsLibpodParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the network exists libpod params
func (o *NetworkExistsLibpodParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the network exists libpod params
func (o *NetworkExistsLibpodParams) WithHTTPClient(client *http.Client) *NetworkExistsLibpodParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the network exists libpod params
func (o *NetworkExistsLibpodParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the network exists libpod params
func (o *NetworkExistsLibpodParams) WithName(name string) *NetworkExistsLibpodParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the network exists libpod params
func (o *NetworkExistsLibpodParams) SetName(name string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *NetworkExistsLibpodParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
