// Code generated by go-swagger; DO NOT EDIT.

package volumes

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewVolumeInspectLibpodParams creates a new VolumeInspectLibpodParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVolumeInspectLibpodParams() *VolumeInspectLibpodParams {
	return &VolumeInspectLibpodParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVolumeInspectLibpodParamsWithTimeout creates a new VolumeInspectLibpodParams object
// with the ability to set a timeout on a request.
func NewVolumeInspectLibpodParamsWithTimeout(timeout time.Duration) *VolumeInspectLibpodParams {
	return &VolumeInspectLibpodParams{
		timeout: timeout,
	}
}

// NewVolumeInspectLibpodParamsWithContext creates a new VolumeInspectLibpodParams object
// with the ability to set a context for a request.
func NewVolumeInspectLibpodParamsWithContext(ctx context.Context) *VolumeInspectLibpodParams {
	return &VolumeInspectLibpodParams{
		Context: ctx,
	}
}

// NewVolumeInspectLibpodParamsWithHTTPClient creates a new VolumeInspectLibpodParams object
// with the ability to set a custom HTTPClient for a request.
func NewVolumeInspectLibpodParamsWithHTTPClient(client *http.Client) *VolumeInspectLibpodParams {
	return &VolumeInspectLibpodParams{
		HTTPClient: client,
	}
}

/*
VolumeInspectLibpodParams contains all the parameters to send to the API endpoint

	for the volume inspect libpod operation.

	Typically these are written to a http.Request.
*/
type VolumeInspectLibpodParams struct {

	/* Name.

	   the name or ID of the volume
	*/
	Name string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the volume inspect libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VolumeInspectLibpodParams) WithDefaults() *VolumeInspectLibpodParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the volume inspect libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VolumeInspectLibpodParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the volume inspect libpod params
func (o *VolumeInspectLibpodParams) WithTimeout(timeout time.Duration) *VolumeInspectLibpodParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the volume inspect libpod params
func (o *VolumeInspectLibpodParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the volume inspect libpod params
func (o *VolumeInspectLibpodParams) WithContext(ctx context.Context) *VolumeInspectLibpodParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the volume inspect libpod params
func (o *VolumeInspectLibpodParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the volume inspect libpod params
func (o *VolumeInspectLibpodParams) WithHTTPClient(client *http.Client) *VolumeInspectLibpodParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the volume inspect libpod params
func (o *VolumeInspectLibpodParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the volume inspect libpod params
func (o *VolumeInspectLibpodParams) WithName(name string) *VolumeInspectLibpodParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the volume inspect libpod params
func (o *VolumeInspectLibpodParams) SetName(name string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *VolumeInspectLibpodParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
